%     VIRTUAL FABRIC - программа для получения эффективных свойств текстильных композитов
%     Copyright (C) 2020  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function [Nodes, Elements, Next_Node_Number, Next_Element_Number] = Mesh_2D_Quadrilateral(Curve_1_start, Curve_1_end, Curve_2_start, Curve_2_end, N_Elements_Along, N_Elements_Across, Next_Node_Number, Next_Element_Number, Set_ID)

N_Nodes_Along = N_Elements_Along + 1;
N_Nodes_Across = N_Elements_Across + 1;

Nodes = zeros(N_Nodes_Along*N_Nodes_Across, 4);
Elements = zeros(N_Elements_Along * N_Elements_Across, 8);

for i=1:N_Nodes_Along
    
    Point_1 = (N_Nodes_Along-i)/(N_Nodes_Along-1)*Curve_1_start + (i-1)/(N_Nodes_Along-1)*Curve_1_end;
    Point_2 = (N_Nodes_Along-i)/(N_Nodes_Along-1)*Curve_2_start + (i-1)/(N_Nodes_Along-1)*Curve_2_end;
    
    for j=1:N_Nodes_Across
        
        Nodes((i-1)*N_Nodes_Across + j,1) = Next_Node_Number;

        Next_Node_Number = Next_Node_Number + 1;
        
        Nodes((i-1)*N_Nodes_Across + j,2) = (N_Nodes_Across-j)/(N_Nodes_Across-1)*Point_1(1) + (j-1)/(N_Nodes_Across-1)*Point_2(1);
        Nodes((i-1)*N_Nodes_Across + j,3) = (N_Nodes_Across-j)/(N_Nodes_Across-1)*Point_1(2) + (j-1)/(N_Nodes_Across-1)*Point_2(2);
        
    end
    
end

for i=1:N_Elements_Along
    
    for j=1:N_Elements_Across
        
        Elements((i-1)*N_Elements_Across + j,1) = Next_Element_Number;

        Next_Element_Number = Next_Element_Number + 1;

        Elements((i-1)*N_Elements_Across + j,2) = 2;
        Elements((i-1)*N_Elements_Across + j,3) = 4;
        Elements((i-1)*N_Elements_Across + j,4) = Set_ID;

        Elements((i-1)*N_Elements_Across + j,5) = Nodes((i-1)*N_Nodes_Across + j,1);
        Elements((i-1)*N_Elements_Across + j,6) = Nodes((i-1)*N_Nodes_Across + j+1,1);
        Elements((i-1)*N_Elements_Across + j,7) = Nodes(i*N_Nodes_Across + j+1,1);
        Elements((i-1)*N_Elements_Across + j,8) = Nodes(i*N_Nodes_Across + j,1);
        
    end
    
end
